/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef SCD_EDITTERM_CPP
#define SCD_EDITTERM_CPP

#include "scd_terminal.cpp"

// ============================================================================

class SCD_EditTerm : public SCD_Terminal , protected wxEvtHandler
{
private:
    bool blChanged;
    int line_capacity;	//term_data \mh֦

	//W٫e[W abs_ 禡u|קƵc, |ø

	bool set_line_capacity(int _dc); //]w̤jieǪ
	bool ensure_line_capacity(int _lc);	//TO _lc iHϥ
	TerminalChar* AllocNewLine();	//tm@һݪOŶ
	void abs_AddLines(int line_index = -1 , int line_count = 1 );
	void abs_DeleteLines(int line_index = -1 , int line_count = 1 );
public:
	void abs_CleanAll();




public:
    bool isChanged()	{	return blChanged;	}
    void setUnchanged()	{	blChanged = false;	}
    
public:
	SCD_EditTerm(wxWindow *win);
	~SCD_EditTerm();

	void keyEnter()
	{
     	int x, y;
     	getXY(&x, &y);

     	int col_count, row_count;
     	getColumnRowCount(&col_count, &row_count);
     	
     	if( term_data[y][x].getCharType() == TerminalChar::CH_WORDLAST )
     		x--;	//YЦbΦr, h@
     	
     	int move_len = getLineLength() - x;
     	if(move_len < 0)	move_len = 0;
     	

		abs_AddLines( y + 1 );	//sW@, JbU@

		TerminalChar dch = TerminalChar::getDefaultCharProperty();

  		for(int i=0;i<move_len;i++)
  		{
  			term_data[y+1][i] = term_data[y][x+i];
  			term_data[y][x+i] = dch;
		}

     	goDown();
     	goLineHead();
		repaint();
		
		blChanged = true;
	}

	void JoinLine(int _line = -1)	//MU@X
	{
		if( _line == -1 )	getXY( NULL , &_line );

      	int col_count, row_count;
      	getColumnRowCount(&col_count, &row_count);
      	if( _line + 1 >= row_count )	return;
      	
      	int now_line_len = getLineLength(_line);
      	if( now_line_len == col_count )	return;
      	int next_line_len = getLineLength(_line+1);
      	
		int move_len = col_count - now_line_len;
		if( move_len > next_line_len )	move_len = next_line_len;
		
		if( term_data[_line+1][move_len-1].getCharType() == TerminalChar::CH_WORDFIRST )
			move_len --;

		for(int i=0;i<move_len;i++)	//U@檺erƻso檺, o溡FάOUSFiƻsF
			term_data[_line][i+now_line_len] = term_data[_line+1][i];

		for(int i=move_len;i<next_line_len;i++)	//Ur꩹eh
			term_data[_line+1][i-move_len] = term_data[_line+1][i];
		
		TerminalChar dch = TerminalChar::getDefaultCharProperty();
		for(int i=1;i<=move_len;i++)	//MU
			term_data[_line+1][next_line_len-i] = dch;
				
   		if( move_len > 0 && move_len < next_line_len )	//pGU٦Ѿl, høoMU
   		{
			wxClientDC dc( getParentWindow() );
			BeginDrawing(&dc);
 			repaintLine(_line);
 			repaintLine(_line+1);
	 		EndDrawing();
		}
		else	//_h, RU, ø
		{
			abs_DeleteLines( _line + 1 );
			repaint();
		}

		blChanged = true;
	}
     
	void keyBackspace()
	{
 		int x, y;
 		getXY(&x, &y);
		if( x == 0 )	//pGЦb歺
  		{
        	if( y == 0 )	return;	//pGbĤ@NX
        	goUp();
        	keyEnd();
        	JoinLine();
		}
		else
		{
			if( isLeftAWord() )	goLeft();
		    goLeft();
	    	keyDelete();
		}

		blChanged = true;
	}
	void keyDelete()
	{
		//pGثeгBrhХ@ 
 		int x, y;
 		getXY(&x, &y);

		if( x >= getLineLength() )	//pGЦb, hX֤U@
		{
      		JoinLine();
      		return;
		}


		if( term_data[y][x].getCharType() == TerminalChar::CH_WORDLAST )
  		{	goLeft();	x--;	}	//YЦbΦr, h@
  		
  		int col_count;
		getColumnRowCount(&col_count , NULL);

 		
 		TerminalChar dch = TerminalChar::getDefaultCharProperty();
 		if( isCurrentAWord() )	//YХثebr}Y, h@RӦr
 		{
	 		for(int i=x+2;i<col_count;i++)
		 		term_data[y][i-2] = term_data[y][i];
 			term_data[y][col_count-1] = dch;
 			term_data[y][col_count-2] = dch;
 		}
		else    //_h, @uR@Ӧr
		{
	 		for(int i=x+1;i<col_count;i++)
		 		term_data[y][i-1] = term_data[y][i];
 			term_data[y][col_count-1] = dch;
		} 			

		adjustLineCharInfo();	//SCD_Terminal::adjustLineCharInfo() iХܳQܪo檺rbr

		blChanged = true;


		//ø
		wxClientDC dc( getParentWindow() );
		BeginDrawing(&dc);
 		repaintLine();
 		EndDrawing();
	}
	void keyInsert();
	
	void keyEnd()
	{
 		int x, y;
 		getXY(&x, &y);
		x = getLineLength();
		int col_count;
		getColumnRowCount(&col_count, NULL);
		if( x >= col_count )	x = col_count - 1;
 		gotoXY( x , y );
	}
	void keyDown()
	{
	    goDown();
	}    

	void keyPageUp()
	{
     	int x, y;
     	getXY(&x, &y);
		int line_count_in_view = getLineCountInView();

     	y = y - (line_count_in_view - 1);
		if(y < 0)	y = 0;

     	gotoXY(x,y);
     	ScrollToCaret();
	}
	void keyPageDown()
	{
     	int x, y;
     	getXY(&x, &y);
		int line_count_in_view = getLineCountInView();

		int row_count;
		getColumnRowCount( NULL, &row_count );

		y = y + line_count_in_view - 1;
		if( y >= row_count - 1 )	y = row_count - 1;

     	gotoXY(x, y);
     	ScrollToCaret();
	}

	void DeleteLineTail()
	{
		//pGثeгBrhХ@ 
 		int x, y;
 		getXY(&x, &y);
		if( term_data[y][x].getCharType() == TerminalChar::CH_WORDLAST )
  			goLeft();

		CleanLineTail();

		wxClientDC dc( getParentWindow() );
		BeginDrawing(&dc);
 		repaintLine();
 		EndDrawing();

		blChanged = true;
	}
	void DeleteLine()
	{
     	int y , row_count;
     	getXY(NULL, &y);
     	getColumnRowCount(NULL , &row_count);
		if( y == row_count - 1 )	return;	//pGb, hX
		
		abs_DeleteLines();
		repaint();

		blChanged = true;
	}

	void setSelectionProperty(int type, bool b, int color)
	{
 		int sx, sy, ex, ey;
	    getSelectionInfo( &sx, &sy, &ex, &ey );

		TerminalChar default_tch = TerminalChar::getDefaultCharProperty();
		char ch;

		int col_count;
  		getColumnRowCount(&col_count, NULL);


		wxClientDC dc( getParentWindow() );
		BeginDrawing(&dc);


	    for(int i=sy;i<=ey;i++)
		{
			for(int j=0;j<col_count;j++)
			{
			    if( i == sy && j < sx )	continue;
			    if( i == ey && j > ex )	continue;
			    
				switch( type )
				{
				    case 0 :
            		{ 
				        TerminalChar & tch = term_data[i][j];
				        ch = tch.ch;
				        default_tch.setCharType( tch.getCharType() );
				        tch = default_tch;
				        tch.ch = ch;
            			break;
					}	 			
				    case 1 : term_data[i][j].setBlink(b);	break;
				    case 2 : term_data[i][j].setHighlight(b);	break;
				    case 3 : term_data[i][j].setUnderline(b);	break;
				    case 4 : term_data[i][j].setTextColor(color);	break;
				    case 5 : term_data[i][j].setBgColor(color);	break;
				}    
			}    
	 		repaintLine(i);
		}		

		if( type == 1 )	setHasBlinkChar(true);

 		EndDrawing();

		blChanged = true;
	}
	void setSelectionNormal()	
	{	setSelectionProperty(0, true, 0);	}
	void setSelectionBlink(bool b)	
	{	setSelectionProperty(1, b, 0);	}
	void setSelectionHighlight(bool b)
	{	setSelectionProperty(2, b, 0);	}
	void setSelectionUnderline(bool b)
	{	setSelectionProperty(3, b, 0);	}
	void setSelectionColor(int color)
	{	setSelectionProperty(4, true, color);	}
	void setSelectionBgColor(int color)	
	{	setSelectionProperty(5, true, color);	}
	

	void PasteFromClipboard(bool withANSI)
	{
		wxString text = GetTextFromClipboard();
		if( text.IsEmpty() )	return;
		else Paste( wxStringToCharPtr(text) , withANSI );
	}
	void Paste(char *txt, bool withANSI)
	{
		txt = strdup( wxStringToCharPtr( GetLineWrapedString(txt) ) );

		//pKWr`@X
		char *p = txt;
		int newline_count = 0;
		while( *p != '\0' )
		{
			if( *p == '\n' )	newline_count ++;
			p ++;
		}

		int col_count;
		getColumnRowCount( &col_count, NULL );

		int bx, by;	//KWeЮy
		getXY(&bx , &by);
		abs_AddLines( by+1 , newline_count );	//sW

		if( term_data[by][bx].getCharType() == TerminalChar::CH_WORDLAST )
		{	goLeft();	bx --;	}	//YЦbΦr, h@

		int b_line_len = getLineLength();
		int buf_len = b_line_len - bx;
		TerminalChar *buf = NULL;
		if( buf_len > 0 )
		{
			buf = new TerminalChar[ buf_len ];
			for(int i=0;i<buf_len;i++)	buf[i] = term_data[by][bx+i];	//ƻsKWe
		}

		DeleteLineTail();	//RKWe

       	EnableDrawing(false);
		parse(txt);	//KWr
		EnableDrawing(true);

		if( buf_len > 0 )
		{
			int ax, ay;	//KW᪺Юy
			getXY(&ax , &ay);
				
			// [KWer] ƻs [KW᪺]
			if( ax + buf_len <= col_count );
			else
			{
  				abs_AddLines( ay+1 );
	   			ax = 0;	ay ++;
			}
			for(int i=0;i<buf_len;i++)	term_data[ay][ax+i] = buf[i];
		}

		if(buf)	delete buf;
		free(txt);

		repaint();

		blChanged = true;
	}

	void OnAsciiChar(char ch)
	{
 		int x, y;
 		getXY(&x, &y);
 		
  		int col_count;
    	getColumnRowCount(&col_count, NULL);

 		for(int i=col_count-1;i>x;i--)	term_data[y][i] = term_data[y][i-1];
 		if(x > 0)	term_data[y][x] = term_data[y][x-1];
	    term_data[y][x].ch = ch;
		adjustLineCharInfo();

		wxClientDC dc( getParentWindow() );
		BeginDrawing(&dc);
		repaintLine();
		EndDrawing();
		
		goRight();

		blChanged = true;
	}

	//**************** ƥ ****************//

	void OnKeyDown(wxKeyEvent& event);
	void OnChar(wxKeyEvent& event);

	void OnMouseLeftDown(wxMouseEvent& event)
	{
	    SCD_Terminal::OnMouseLeftDown(event);

	    int x, y;
	    MouseXY_to_TextXY( event.GetX(), event.GetY(), x, y);
	    gotoXY(x,y);
	    if( term_data[y][x].getCharType() == TerminalChar::CH_WORDLAST )	goLeft();	//TOѼФ|bΦrĤG byte
	}

	void OnMouseMotion(wxMouseEvent& event)
	{
	    SCD_Terminal::OnMouseMotion(event);

	    if( selectState == 2 )	//br 
		{
		    int x, y;
		    MouseXY_to_TextXY( event.GetX(), event.GetY(), x, y);
	    	gotoXY(x,y);
		    if( term_data[y][x].getCharType() == TerminalChar::CH_WORDLAST )	goLeft();	//TOѼФ|bΦrĤG byte
		}
	}    

};

// ============================================================================

SCD_EditTerm::SCD_EditTerm(wxWindow *win) : SCD_Terminal(win)
{
    blChanged = false;
    getColumnRowCount(NULL , & line_capacity );
}
SCD_EditTerm::~SCD_EditTerm()
{
}    






bool SCD_EditTerm::set_line_capacity(int _dc) //]w̤jieǪ
{
    int row_count;
	getColumnRowCount(NULL , & row_count );
	if( _dc < row_count )	return false;

	TerminalChar **tmp_lines = term_data;
	term_data = new (TerminalChar*)[_dc];
	if(term_data==NULL)
	{
		term_data = tmp_lines;
		return false;
	}

	for(int i=0;i<row_count;i++) term_data[i] = tmp_lines[i];
	delete tmp_lines;

	return true;
}

bool SCD_EditTerm::ensure_line_capacity(int _lc)	//TO _lc iHϥ
{
	if( _lc <= line_capacity )	return true;
	else return set_line_capacity( _lc + 100 );
}

TerminalChar* SCD_EditTerm::AllocNewLine()	//tm@һݪOŶ
{
    int col_count;
	getColumnRowCount( &col_count , NULL );

	TerminalChar *line = new TerminalChar[ col_count ];

	TerminalChar dch = TerminalChar::getDefaultCharProperty();
	for(int i=0;i<col_count;i++)	line[i] = dch;

	return line;
}

void SCD_EditTerm::abs_AddLines(int line_index , int line_count )
{
    if( line_index == -1 )	getXY(NULL, &line_index);
    int col_count, row_count;
	getColumnRowCount(&col_count , & row_count );

	ensure_line_capacity(row_count + line_count);

	int move_count = row_count - line_index;
	for(int c=0 , s=row_count-1 , d=s+line_count ; c<move_count ; c++ , s--, d--)
		term_data[d] = term_data[s];	//h
	for(int i=0;i<line_count;i++)	//sW
		term_data[i+line_index] = AllocNewLine();
		
	updateScrollBar(row_count + line_count);
}

void SCD_EditTerm::abs_DeleteLines(int line_index , int line_count )
{
    if( line_index == -1 )	getXY(NULL, &line_index);
    int col_count, row_count;
	getColumnRowCount(&col_count , & row_count );

 	for(int i=0;i<line_count;i++)	delete term_data[i + line_index];	//R
 	for(int d=line_index , s=line_index+line_count ; s < row_count ; s++ , d++ )
 		term_data[d] = term_data[s];	//h

	ensure_line_capacity(row_count - line_count);
	updateScrollBar(row_count - line_count);
}

void SCD_EditTerm::abs_CleanAll()
{
    int row_count;
    getColumnRowCount(NULL , &row_count);
    gotoXY(0,0);
    abs_AddLines(0, 1);
    abs_DeleteLines(1, row_count);
}





void SCD_EditTerm::OnChar(wxKeyEvent& event)
{
	int key = event.GetKeyCode();
//	wxMessageBox( wxString::Format("%d", key) );
	OnAsciiChar( (char)key );
}    

void SCD_EditTerm::OnKeyDown(wxKeyEvent& event)
{
	int key = event.GetKeyCode();

	if( key == WXK_DELETE )	keyDelete();
	else if( key == WXK_RETURN )	keyEnter();	//[Enter]
	else if( key == WXK_BACK )	keyBackspace();	//back space
	else if( key == 395 )	OnAsciiChar('.');	//Lk, Ʀr [pI] 
	else if( isascii(key) )		event.Skip();	//浹 OnChar event Bz
	else
	{
		if( key >= 326 && key <= 335 )	//pGOLk䪺Ʀr
		{
  			char ch = (char)(key - 326) + '0';
			parse( (char*)&ch , 1 );
		}
		else
		{
			switch(key)
			{
/*
				case WXK_BACK :	output = "";	break;
				case WXK_TAB :	output = "";	break;
				case WXK_RETURN :	output = "";	break;
				case WXK_ESCAPE :	output = "";	break;
				case WXK_DELETE :	output = "\x1b\x5b\x33\x7e";	break;
*/
				case WXK_HOME :		goLineHead();	break;
				case WXK_END :		keyEnd();	break;
				case WXK_INSERT :	break;
				case WXK_UP :		goUp();		break;
				case WXK_DOWN :		keyDown();	break;
				case WXK_LEFT :		
           			if( isLeftAWord() )	goLeft();
           			goLeft();
              		break;
				case WXK_RIGHT :	
    		    	if( isCurrentAWord() )	goRight();
              		goRight();
                	break;
				case 312 :	keyPageUp();	break;	//page up
				case 313 :	keyPageDown();	break;	//page down

				default :
//wxMessageBox(wxString::Format("%d", key) );
				if(key >= 0x40 && key < 0xff)	event.Skip();	//浹 OnChar event Bz
					break;
			}
		}
	}

}

// ============================================================================
#endif
